import { Application } from 'express';
import { Resource } from 'express-automatic-routes';
import { BuildingProvider } from '#providers/BuildingProvider';
import { Req, Res } from '#interfaces/IApi';
import verify, { requireAdmin } from '#middlewares/auth';
import { validateId } from '#middlewares/validators';
import { Errors } from '#interfaces/error';
import { sendSuccess } from '#utils/responseUtils';

export default (_express: Application) => {
	const buildingProvider = BuildingProvider.getInstance();
	return <Resource>{
		delete: {
			middleware: [verify, requireAdmin, validateId],
			handler: async (req: Req, res: Res) => {
				try {
					const building = await buildingProvider.getById({ id: req.params.id! });

					if (!building) {
						throw Errors.notFound('Building');
					}

					const success = await buildingProvider.forceDelete(req.params.id!);

					return sendSuccess(res, success);
				} catch (error) {
					return res.error(error);
				}
			},
		},
	};
};
